Ticket #33922

タブを含むテキストで点字ディスプレイ出力がずれる

Open Date: 2014-06-07 17:55 Last Update: 2014-06-14 10:21

Reporter: nishimoto Owner: nishimoto
Type: Bugs Status: Closed
Component: 点字ディスプレイ MileStone: 2014.3jp-public-beta (closed)
Priority: 5 - Medium Severity: 5 - Medium
Resolution: Fixed

Details

以下、Dummy Braille ドライバーで確認した状況なので、実機では未確認ですが、 おそらく同じ状況だと思うので書いておきます。

2014.2jp で点字出力を「日本語」にして、メモ帳で「文字変換」(ローマ字)

a Enter Tab a Enter

つまり「あ」タブ文字「あ」を入力します。

点字ディスプレイには

1 0 0 1

(ただし 0 は空白セル)のように表示されます。

左端にキャレットがある状態から、右矢印を押して右に1文字移動すると、 「タブ」と読み上げます。

画面では最初の「あ」のすぐ右側にキャレットが表示されます。

このとき、点字ディスプレイでは第4セルの 1 の場所がブリンクします。

さらに右矢印キーを押すと、 「あ」と読み上げます。

画面では2個目の「あ」の左側(タブの直後)にキャレットが表示されます。

点字ディスプレイでは「1の点」のさらに右側のセルがブリンクしています。

タブ文字を日本語点訳エンジンが正しく処理できておらず、 ポジションマッピングがずれているようです。

Attachment File List

No attachments

Ticket History (3/5 Histories)

2014-06-07 17:55 Updated by: nishimoto
  • New Ticket "タブを含むテキストで点字ディスプレイ出力がずれる" created
2014-06-10 14:17 Updated by: nishimoto
Comment

メモ帳でタブがどのように表示されるか liblouis の仕様を確認:

アメリカ英語6点コンピューター点字(コンピューター点字のチェックなし):

  • Tab 1個が「7の点」1個で表示される
  • ブリンクカーソルと重なるときにも「7の点」のまま

アメリカ英語6点コンピューター点字(コンピューター点字のチェックあり):

  • Tab 1個が「7の点」1個で表示される
  • ただしブリンクカーソルと重なるときには「4の点」で表示される

統一英語点字1級点字(コンピューター点字のチェックなし):

  • Tab 1個がスペース1個として表示される。スペースとは区別がつかない

統一英語点字1級点字(コンピューター点字のチェックあり):

  • Tab 1個がスペース1個として表示される。スペースとは区別がつかない。
  • アルファベットや記号はキャレットの位置によってUEBとNABCCが切り替わるが、タブには影響しない。
2014-06-10 16:01 Updated by: nishimoto
Comment

ti31182v2 ブランチで本作業を合わせて行っています。

テキスト解析の前にタブ文字を U+2840 (7の点)に置き換えておく実装にしています。

2014-06-12 09:22 Updated by: nishimoto
Comment

本作業はチケット #31182 の作業と一緒に jpbeta ブランチにマージされています。

アメリカ英語点字での挙動に合わせて、7の点でタブを表現しています。 (キャレットが重なったときにも4の点ではなく7の点のままです)

この実装は NABCC モードにかかわらず同じ仕様にしましたが、 7の点がタブを表すことを知らないユーザーもいるのではないか、というご指摘をいただいています。

ドキュメントに説明を書こうと思いますが、仕様についてご意見があればお聞かせください。

2014-06-14 10:21 Updated by: nishimoto
  • Ticket Close date is changed to 2014-06-14 10:21
  • Status Update from Open to Closed
Comment

このチケットはクローズして、残った作業は #31182 で扱います。

Edit

Please login to add comment to this ticket » Login